import _Widget = require("../_Widget");
import _TemplatedMixin = require("../_TemplatedMixin");
import _CssStateMixin = require("../_CssStateMixin");
import { _WidgetBaseConstructor } from "../_WidgetBase";
import _FormWidgetMixin = require("./_FormWidgetMixin");

interface _FormWidget extends _Widget, _TemplatedMixin, _CssStateMixin, _FormWidgetMixin {
    setDisabled(disabled: boolean): void;
    setValue(value: string): void;
    postMixInProperties(): void;

    set(name: 'value', value: string): this;
    set(name: string, value: any): this;
    set(values: Object): this;
}

type _FormWidgetConstructor = _WidgetBaseConstructor<_FormWidget>;
declare const _FormWidget: _FormWidgetConstructor;
export = _FormWidget;